import java.util.Arrays;

public class DemoArray {

    public static void main(String... args) {

        Array<String> stringArray = new Array<>(0);

        // bubble sort
        Array<Integer> list = new Array<Integer>(9).init(new Integer[] { 3, 5, 7, 4, 8, 0, 2, 1, 6 });
        System.out.println(Arrays.toString(list.toArray()));

        boolean swapFlag = true;
        while (swapFlag) {
            swapFlag = false;
            for (int x = 0; x < list.size() - 2; x++) {
                if (list.get(x).compareTo(list.get(x + 1)) > 0) {
                    Integer temp = list.get(x);
                    list.set(list.get(x + 1), x);
                    list.set(temp, (x + 1));
                    swapFlag = true;
                } // end if
            } // end for
        } // end while

        System.out.println(Arrays.toString(list.toArray()));

        System.out.println(list.toString());

        // multiplication table
        Array<Integer> multiplyTable = new Array<Integer>(10, 10).init(0);

        for (int x = 0; x < multiplyTable.getDim(0); x++) {
            for (int y = 0; y < multiplyTable.getDim(1); y++) {
                multiplyTable.set(x * y, x, y);
            } // end for
        } // end for

        // check 1*n = n
        for (int x = 0; x < multiplyTable.getDim(0); x++) {
            if (multiplyTable.get(1, x) != x)
                throw new RuntimeException("Identity property doesn't hold!");
            if (multiplyTable.get(x, 1) != x)
                throw new RuntimeException("Identity property doesn't hold!");
        } // end for

        // check m*n = n*m
        for (int x = 0; x < multiplyTable.getDim(0); x++) {
            for (int y = 0; y < multiplyTable.getDim(1); y++) {
                if (multiplyTable.get(x, y) != multiplyTable.get(y, x))
                    throw new RuntimeException("Commutative property doesn't hold!");
            } // end for
        } // end for

        System.out.println(multiplyTable.toString());

        //Integer[] intList = new Integer[multiplyTable.size()];

        Object[] intList = multiplyTable.toArray();

        System.out.println(Arrays.toString(intList));


        System.exit(0);

    }// end main

}// end class DemoArray
